﻿/*
* Created on 15.May.2005
*/
using System;
using System.Configuration;
using System.Net;
using System.Resources; 
using System.IO;
using Newtonsoft.Json;



namespace xml.sender
{
	
	/// <author>  mustafa.bilge
	/// </author>
	/// <returns> This class is not accessible from outside.
	/// </returns>
	public abstract class SmsBase
	{
        virtual public System.String Version
        {
            get
            {
                if ((System.Object)version == null)
                    return "";
                return version;
            }

            set
            {
                this.version = value;
            }

        }

		//UPGRADE_NOTE: Respective javadoc comments were merged.  It should be changed in order to comply with .NET documentation conventions.
		/// <returns> Returns the expireDate.
		/// </returns>
		/// <param name="expireDate">The expireDate to set.
		/// </param>
		virtual public System.String ExpireDate
		{
			get
			{
				if ((System.Object) expireDate == null)
					return "";
				return expireDate;
			}
			
			set
			{
				this.expireDate = value;
			}
			
		}
        //UPGRADE_NOTE: Respective javadoc comments were merged.  It should be changed in order to comply with .NET documentation conventions.
        /// <returns> Returns the channel.
        /// </returns>
        /// <param name="channel">The channel which corresponds to channel to set.
        /// </param>
        virtual public System.String ChannelType
        {
            get
            {
                return Channel;
            }

            set
            {
                Channel = value;
            }

        }
		//UPGRADE_NOTE: Respective javadoc comments were merged.  It should be changed in order to comply with .NET documentation conventions.
		/// <returns> Returns the outboxName.
		/// </returns>
		/// <param name="originator">The originator which corresponds to outboxName to set.
		/// </param>
		virtual public System.String Originator
		{
			get
			{
				return OutboxName;
			}
			
			set
			{
				OutboxName = value;
			}
			
		}
        //UPGRADE_NOTE: Respective javadoc comments were merged.  It should be changed in order to comply with .NET documentation conventions.
        /// <returns> Returns the channel.
        /// </returns>
        /// <param name="channel">The channel to set.
        /// </param>
        virtual public System.String Channel
        {
            get
            {
                if ((System.Object)channel == null)
                    throw new SmsCreationException("Channel must be set in the message.");
                return channel;
            }

            set
            {
                this.channel = value;
            }

        }
		//UPGRADE_NOTE: Respective javadoc comments were merged.  It should be changed in order to comply with .NET documentation conventions.
		/// <returns> Returns the outboxName.
		/// </returns>
		/// <param name="outboxName">The outboxName to set.
		/// </param>
		virtual public System.String OutboxName
		{
			get
			{
				if ((System.Object) outboxName == null)
					throw new SmsCreationException("OutboxName must be set in the message.");
				return outboxName;
			}
			
			set
			{
				this.outboxName = value;
			}
			
		}
		//UPGRADE_NOTE: Respective javadoc comments were merged.  It should be changed in order to comply with .NET documentation conventions.
		/// <returns> Returns the password.
		/// </returns>
		/// <param name="password">The password to set.
		/// </param>
		virtual public System.String Password
		{
			get
			{
				if ((System.Object) password == null)
					throw new SmsCreationException("Password must be set in the message.");
				return password;
			}
			
			set
			{
				this.password = value;
			}
			
		}
		//UPGRADE_NOTE: Respective javadoc comments were merged.  It should be changed in order to comply with .NET documentation conventions.
		/// <returns> Returns the reference.
		/// </returns>
		/// <param name="reference">The reference to set.
		/// </param>
		virtual public System.String Reference
		{
			get
			{
				if ((System.Object) reference == null)
					return "";
				return reference;
			}
			
			set
			{
				this.reference = value;
			}
			
		}
		//UPGRADE_NOTE: Respective javadoc comments were merged.  It should be changed in order to comply with .NET documentation conventions.
		/// <returns> Returns the startDate.
		/// </returns>
		/// <param name="startDate">The startDate to set.
		/// </param>
		virtual public System.String StartDate
		{
			get
			{
				if ((System.Object) startDate == null)
					return "";
				return startDate;
			}
			
			set
			{
				this.startDate = value;
			}
			
		}
		//UPGRADE_NOTE: Respective javadoc comments were merged.  It should be changed in order to comply with .NET documentation conventions.
		/// <returns> Returns the username.
		/// </returns>
		/// <param name="username">The username to set.
		/// </param>
		virtual public System.String Username
		{
			get
			{
				if ((System.Object) username == null)
					throw new SmsCreationException("Username must be set in the message.");
				return username;
			}
			
			set
			{
				this.username = value;
			}
			
		}

        virtual public System.String MessageType
        {
            get
            {
                if ((System.Object)messageType == null)
                    return "";
                return messageType;
            }

            set
            {
                this.messageType = value;
            }

        }
        //UPGRADE_NOTE: Respective javadoc comments were merged.  It should be changed in order to comply with .NET documentation conventions.
        /// <returns> Returns the username.
        /// </returns>
        /// <param name="MessageHeader">The username to set.
        /// </param>		
        virtual public System.String MessageHeader
        {
            get
            {
                if ((System.Object)messageHeader == null)
                    return "0";
                return messageHeader;
            }

            set
            {
                this.messageHeader = value;
            }

        }
        //UPGRADE_NOTE: Respective javadoc comments were merged.  It should be changed in order to comply with .NET documentation conventions.
        /// <returns> Returns the username.
        /// </returns>
        /// <param name="MultipleSend">The username to set.
        /// </param>		
        virtual public System.String MultipleSend
        {
            get
            {
                if ((System.Object)multipleSend == null)
                    return "";
                return multipleSend;
            }

            set
            {
                this.multipleSend = value;
            }

        }
               
        /// <returns> Returns the username.
        /// </returns>
        /// <param name="username">The username to set.
        /// </param>
        virtual protected System.Boolean isResponseMultiGroupId
        {
            get
            {
                return _isResponseMultiGroupId;
            }

            set
            {
                this._isResponseMultiGroupId = value;
            }

        }

        /// Hold email address (comma separated list)
        /// <returns> Returns the emailReportAddress.
		/// </returns>
        /// <param name="username">The emailReportAddress to set.
		/// </param>
        virtual public System.String EmailReportAddress
		{
            get { return this.emailReportAddress; }
            set { this.emailReportAddress = value; }			
		}

		virtual public System.String GsmNumber
		{
			get { return gsmNumber; }
			set { gsmNumber = value; }
		}

		virtual public System.String ExclusionTimeStart
		{
			get { return exclusionTimeStart; }
			set { exclusionTimeStart = value; }
		}
		
		virtual public System.String ExclusionTimeStop
		{
			get { return exclusionTimeStop; }
			set { exclusionTimeStop = value; }
		}

        /// <summary>
        /// Gets or sets the state of the package.
        /// 1 : Parçalı XML'in ilk parçası
        /// 2 : Parçalı XML'in aradaki parçaları 
        /// 3 : Parçalı XML'in son parçası
        /// </summary>
        /// <value>The state of the package.</value>
        virtual public byte PackageState
        {
            get { return _packageState; }
            set { _packageState = value; }
        }

        /// <summary>
        /// Gets or sets the sequence number of the package. 
        /// </summary>
        /// <value>The state of the package.</value>
        virtual public int TrnSqn
        {
            get { return _trnSqn; }
            set { _trnSqn = value; }
        }

        /// <summary>
        /// Gets or sets the total message count.
        /// Gönderimin toplam mesaj sayısı.
        /// (1 Gönderim n-packet üzere gidebilir)
        /// </summary>
        /// <value>The total message count.</value>
        virtual public int TotalMessageCount 
        {
            get { return _totalMessageCount; }
            set { _totalMessageCount = value; }
        }

        ///// <summary>
        ///// Gets or sets the current unit message count.
        ///// Bu packet içerisindeki mesaj sayısı
        ///// </summary>
        ///// <value>The current unit message count.</value>
        //virtual public int CurrentUnitMessageCount 
        //{
        //    get { return _currentUnitMessageCount; }
        //    set { _currentUnitMessageCount = value; }
        //}

        /// <summary>
        /// Gets or sets the operation process ID.
        /// Gönderim birden fazla pakete ayrılmış
        /// fakat hepsinin process ID ortak
        /// </summary>
        /// <value>The operation process ID.</value>
        virtual public String OperationProcessID 
        {
            get { return _operationProcessID; }
            set { _operationProcessID = value; }
        }

        /// <summary>
        /// Gets or sets the type of the process.
        /// Hangi source'dan veri alındığı tutar
        /// Excel vb.
        /// </summary>
        /// <value>The type of the process.</value>
        virtual public String ProcessType 
        {
            get { return _processType; }
            set { _processType = value; }
        }

        /// <summary> 
        /// Kara Liste kontrolu aktif olup olmayacagi
        /// secilir.
        /// Default olarak bu ozellik aktifdir.
        /// </summary>
        /// <value>The type of the process.</value>
        virtual public bool IsBlacklistFilterActive
        {
            get { return _blacklistFilterActive; }
            set { _blacklistFilterActive = value; }
        }

        /// <summary> 
        /// Izinli Veritabani kontrolu aktif olup olmayacagi
        /// secilir.
        /// Default olarak bu ozellik aktifdir.
        /// </summary>
        /// <value>The type of the process.</value>
        virtual public bool IsOptinFilterActive
        {
            get { return _optinFilterActive; }
            set { _optinFilterActive = value; }
        }

        virtual public bool Compressed
        {
            get { return _compressed; }
            set { _compressed = value; }
        }

        /// <summary> 
        /// TCKN gonderim olup olmadigi secilir.
        /// Default olarak bu ozellik pasifdir.
        /// </summary>
        /// <value>The type of the process.</value>
        virtual public bool IsTCKN
        {
            get { return _isTCKN; }
            set { _isTCKN = value; }
        }

        /// <summary> 
        /// VKN gonderim olup olmadigi secilir.
        /// Default olarak bu ozellik pasifdir.
        /// </summary>
        /// <value>The type of the process.</value>
        virtual public bool IsVKN
        {
            get { return _isVKN; }
            set { _isVKN = value; }
        }

        /// <summary>
        /// Gets or sets the type of the process.
        /// Hangi source'dan veri alındığı tutar
        /// Excel vb.
        /// </summary>
        /// <value>The type of the process.</value>
        virtual public IWebProxy  Proxy
        {
            set { _proxy = value; }
        }
 
        virtual public Int32 Timeout
        {
            get { return _timeout; }
            set { _timeout = value; }
        }

        private System.String version;
		private System.String username;
		private System.String password;
        private System.String messageType;
        private System.String messageHeader;
        private System.String outboxName;
        private System.String emailReportAddress;
		private System.String reference;
		private System.String startDate;
		private System.String expireDate;
		private System.String gsmNumber;
		private System.String exclusionTimeStart;
		private System.String exclusionTimeStop;
        private byte _packageState;
        private int _totalMessageCount;
        private int _currentUnitMessageCount;
        private String _operationProcessID;
        private String _processType;
        private int _trnSqn;
        private IWebProxy _proxy = null;
        private bool _blacklistFilterActive = true;
        private bool _optinFilterActive = false;
        private int _timeout = 100;

        private bool _compressed = false;

        private bool _isTCKN = false;
        private bool _isVKN = false; 

        private System.String channel;
        private System.String multipleSend;
        private bool _isResponseMultiGroupId = false; 

		public abstract ResponseFromHost sendMessage();
        public abstract ResponseFromHostV2 sendMessageV2();
        
        protected internal virtual ResponseFromHost PostDataToHost(System.String xmltoSend, System.String xmlSentServlet)
        {
            HttpClient httpClient = new HttpClient(xmlSentServlet, _compressed);

            httpClient.connectAndPostData(xmltoSend, _proxy, (_timeout == 100 ? 0 : _timeout * 1000));
			System.String response = httpClient.Response;
            
            if (string.IsNullOrEmpty(response))
            {
                throw new Exception("İletişim sorunu yaşandı. Tekrarlamanız halinde mükerrer gönderebilirsiniz. Müşteri Hizmetleri ile iletişime geçiniz");
            }

			System.String code = response.Substring(0, (2) - (0));
			System.String message = response.Substring(2).Trim();
			
            //try 
            //{
            //    StreamWriter sw1 = new StreamWriter("log.txt", true);
            //    sw1.WriteLine(xmlSentServlet +" "+xmltoSend);
            //    sw1.Flush();
            //    sw1.Close() ;
            //} 
            //catch(Exception e)
            //{
            //}

			return new ResponseFromHost(code, message);
		}

        protected internal virtual ResponseFromHostV2 PostDataToHostV2(System.String xmltoSend, System.String xmlSentServlet)
        {
            ResponseFromHostV2 responseFromHostV2 = null;

            HttpClient httpClient = new HttpClient(xmlSentServlet, _compressed);

            httpClient.connectAndPostData(xmltoSend, _proxy, (_timeout == 100 ? 0 : _timeout * 1000));
            System.String response = httpClient.ResponseAndDisconnect;

            if (string.IsNullOrEmpty(response))
            {
                throw new Exception("İletişim sorunu yaşandı. Tekrarlamanız halinde mükerrer gönderebilirsiniz. Müşteri Hizmetleri ile iletişime geçiniz");
            }
            
            
            responseFromHostV2 = JsonConvert.DeserializeObject<ResponseFromHostV2>(response);

            return responseFromHostV2;
        }

		/*protected internal virtual ResponseFromBioTekno postDataToBioTekno(System.String xmltoSend)
		{
			try
			{
				SettingReader sr = new SettingReader();
				String urlStr = sr.GetKeyValue("XML_SENT_SERVLET");

					//smsproxy.XmlSentServlet;
				//ConfigurationSettings.AppSettings["XML_SENT_SERVLET"]

				if(urlStr == null)
				{
					throw new Exception("Set the XML_SENT_SERVLET property on configuration file first");
				}

				HttpClient httpClient = new HttpClient(urlStr);

				httpClient.connectAndPostData(xmltoSend);
				System.String response = httpClient.ResponseAndDisconnect;
				System.String code = response.Substring(0, (2) - (0));
				System.String message = response.Substring(2).Trim();

				return new ResponseFromBioTekno(code, message);
			}
			catch (System.Exception ex)
			{
				//UPGRADE_TODO: The equivalent in .NET for method 'java.lang.Throwable.getMessage' may return a different value. 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="jlca1043"'
				throw new SmsSendException("Exception: " + ex.Message);
			}
		}*/

		protected internal virtual ResponseFromHost PostDataToHost(System.String xmltoSend)
		{
			try
			{
                SettingReader sr = new SettingReader();
				String urlStr = sr.GetKeyValue("XML_SENT_SERVLET");

				//smsproxy.XmlSentServlet;
				//ConfigurationSettings.AppSettings["XML_SENT_SERVLET"]

				if(urlStr == null)
				{
					throw new Exception("Set the XML_SENT_SERVLET property on configuration file first");
				}

				return PostDataToHost(xmltoSend, urlStr);				
			}
			catch (System.Exception ex)
			{
				//UPGRADE_TODO: The equivalent in .NET for method 'java.lang.Throwable.getMessage' may return a different value. 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="jlca1043"'
				throw new SmsSendException("Exception: " + ex.Message);
			}
		}

        [Obsolete]
        protected internal virtual ResponseFromHostV2 PostDataToHostV2(System.String xmltoSend)
        {
            try
            {
                return PostDataToHostV2(xmltoSend, ConfigurationSettings.AppSettings["XML_SENT_SERVLET"]);
            }
            catch (System.Exception ex)
            {
                //UPGRADE_TODO: The equivalent in .NET for method 'java.lang.Throwable.getMessage' may return a different value. 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="jlca1043"'
                throw new SmsSendException("Exception: " + ex.Message);
            }
        }

        /*multi message_id*/
        protected internal virtual Decimal GetMessageId()
        {
            //return DateTime.Now.ToString("yyMMddHHmmssfffffff");
            Decimal t = Math.Ceiling((Decimal)(DateTime.Now.Ticks / 1000));
            int r = GetRandomNumber(10000,99999);
            int l = 1000000;

            return Convert.ToDecimal(Math.Ceiling((Decimal)(DateTime.Now.Ticks / 1000)).ToString() + GetRandomNumber(10000, 99999).ToString() + "1000000");
        }

        private static readonly Random getrandom = new Random();
        private static readonly object syncLock = new object();
        public static int GetRandomNumber(int min, int max)
        {
            lock (syncLock)
            { // synchronize
                return getrandom.Next(min, max);
            }
        }
		
		[STAThread]
		protected static void  Main(System.String[] args)
		{
		}
	}
}