﻿/*
* Created on 15.May.2005
*/
using System;
using System.Text;

namespace xml.sender
{
	
	/// <author>  mustafa.bilge
	/// </author>
	/// <returns> It simulates the mobile phone i.e.
	/// the Gsm Number and the Sms message.
	/// </returns>
	public class SmsMessage
	{
		//UPGRADE_NOTE: Respective javadoc comments were merged.  It should be changed in order to comply with .NET documentation conventions.
		/// <returns> Returns the gsmNumber.
		/// @throws SmsCreationException
		/// </returns>
		/// <param name="gsmNumber">The gsmNumber to set.
		/// </param>
		virtual public System.String GsmNumber
		{
			get
			{
                if ((System.Object)gsmNumber == null)
					throw new SmsCreationException("Gsm Number must be set in the message."); 
				
				return gsmNumber;
			}
			
			set
			{
				this.gsmNumber = value;
			}
			
		}

        //UPGRADE_NOTE: Respective javadoc comments were merged.  It should be changed in order to comply with .NET documentation conventions.
        /// <returns> Returns the MessageStartdate.
        /// @throws SmsCreationException
        /// </returns>
        /// <param name="messageStartDate">The messageStartDate to set.
        /// </param>
        virtual public System.String MessageStartDate
        {
            get
            {
                if ((System.Object)messageStartDate == null)
                    return "";

                return messageStartDate;
            }

            set
            {
                this.messageStartDate = value;
            }

        }

        //UPGRADE_NOTE: Respective javadoc comments were merged.  It should be changed in order to comply with .NET documentation conventions.
        /// <returns> Returns the MessageExpireDate.
        /// @throws SmsCreationException
        /// </returns>
        /// <param name="messageExpireDate">The messageExpireDate to set.
        /// </param>
        virtual public System.String MessageExpireDate
        {
            get
            {
                if ((System.Object)messageExpireDate == null)
                    return "";

                return messageExpireDate;
            }

            set
            {
                this.messageExpireDate = value;
            }

        }

        //UPGRADE_NOTE: Respective javadoc comments were merged.  It should be changed in order to comply with .NET documentation conventions.
        /// <returns> Returns the MessageExpireDate.
        /// @throws SmsCreationException
        /// </returns>
        /// <param name="messageExclusionTimeStart">The messageExpireDate to set.
        /// </param>
        virtual public System.String MessageExclusionTimeStart
        {
            get
            {
                if ((System.Object)messageExclusionTimeStart == null)
                    return "";

                return messageExclusionTimeStart;
            }

            set
            {
                this.messageExclusionTimeStart = value;
            }

        }

        //UPGRADE_NOTE: Respective javadoc comments were merged.  It should be changed in order to comply with .NET documentation conventions.
        /// <returns> Returns the MessageExpireDate.
        /// @throws SmsCreationException
        /// </returns>
        /// <param name="messageExclusionTimeStop">The messageExpireDate to set.
        /// </param>
        virtual public System.String MessageExclusionTimeStop
        {
            get
            {
                if ((System.Object)messageExclusionTimeStop == null)
                    return "";

                return messageExclusionTimeStop;
            }

            set
            {
                this.messageExclusionTimeStop = value;
            }

        }

        /// <returns> Returns the gsmNumber.
        /// @throws SmsCreationException
        /// </returns>
        /// <param name="gsmNumber">The gsmNumber to set.
        /// </param>
        virtual public System.Decimal MessageId
        {
            get
            {

                return messageId;
            }

            set
            {
                this.messageId = value;
            }

        }

		private string ConvertNonEnglishChar(string xml)
		{
			/*
			xml = xml.Replace("İ","I");
			xml = xml.Replace("Ğ","G");
			xml = xml.Replace("ğ","g");
			xml = xml.Replace("Ş","S");
			xml = xml.Replace("ş","s");
			xml = xml.Replace("Ü","U");
			xml = xml.Replace("ü","u");
			xml = xml.Replace("ı","i");
			xml = xml.Replace("Ç","C");
			xml = xml.Replace("ç","c");
			xml = xml.Replace("Ö","O");
			xml = xml.Replace("ö","o");
			*/
			return xml;
		}

		//UPGRADE_NOTE: Respective javadoc comments were merged.  It should be changed in order to comply with .NET documentation conventions.
		/// <returns> Returns the text.
		/// @throws SmsCreationException
		/// </returns>
		/// <param name="text">The text to set.
		/// </param>
		virtual public System.String Text
		{
			get
			{
				if ((System.Object) text == null)
					throw new SmsCreationException("Text must be set in the message.");
				return text;
			}
			
			set
			{
				this.text = ConvertNonEnglishChar(value);
			}
			
		}
		//UPGRADE_NOTE: Respective javadoc comments were merged.  It should be changed in order to comply with .NET documentation conventions.
		/// <returns> Returns the username.
		/// </returns>
		/// <param name="MessageType">The username to set.
		/// </param>		

		virtual public System.String MessageType
		{
			get
			{
				if ((System.Object) messageType == null)
					return "0";
				return messageType;
			}
			
			set
			{
				this.messageType = value;
			}
			
		}
		//UPGRADE_NOTE: Respective javadoc comments were merged.  It should be changed in order to comply with .NET documentation conventions.
		/// <returns> Returns the username.
		/// </returns>
		/// <param name="MessageHeader">The username to set.
		/// </param>		
		virtual public System.String MessageHeader
		{
			get
			{
				if ((System.Object) messageHeader == null)
					return "";
				return messageHeader;
			}
			
			set
			{
				this.messageHeader = value;
			}
			
		}

		
		private System.String gsmNumber;
		private System.String text;
		private System.String messageType;
		private System.String messageHeader;
        private System.String messageStartDate;
        private System.String messageExpireDate;
        private System.String messageExclusionTimeStart;
        private System.String messageExclusionTimeStop;

        private System.Decimal messageId = -1;
		
		public SmsMessage()
		{
		}
		public SmsMessage(System.String gsmNumber, System.String text)
		{
			GsmNumber = gsmNumber;
			Text = text;
		}
		public SmsMessage(System.String gsmNumber, System.String text,System.String messageType,System.String messageHeader)
		{
			GsmNumber = gsmNumber;
			Text = text;
			MessageType = messageType;
			MessageHeader = messageHeader;
		}
        public SmsMessage(System.String gsmNumber, System.String text, System.String messageType, System.String messageHeader, System.String messageStartDate, System.String messageExpireDate)
        {
            GsmNumber = gsmNumber;
            Text = text;
            MessageType = messageType;
            MessageHeader = messageHeader;
            MessageStartDate = messageStartDate;
            MessageExpireDate = messageExpireDate;
        }
        public SmsMessage(System.String gsmNumber, System.String text, System.String messageType, System.String messageHeader, System.String messageStartDate, System.String messageExpireDate, System.String messageExclusionTimeStart, System.String messageExclusionTimeStop)
        {
            GsmNumber = gsmNumber;
            Text = text;
            MessageType = messageType;
            MessageHeader = messageHeader;
            MessageStartDate = messageStartDate;
            MessageExpireDate = messageExpireDate;
            MessageExclusionTimeStart = messageExclusionTimeStart;
            MessageExclusionTimeStop = messageExclusionTimeStop;
        }

        /*multi message_id*/
        public SmsMessage(System.String gsmNumber, System.String text,System.Decimal messageId)
        {
            GsmNumber = gsmNumber;
            Text = text;
            MessageId = messageId;
        }
        public SmsMessage(System.String gsmNumber, System.String text, System.String messageType, System.String messageHeader, System.Decimal messageId)
        {
            GsmNumber = gsmNumber;
            Text = text;
            MessageType = messageType;
            MessageHeader = messageHeader;
            MessageId = messageId;
        }
        public SmsMessage(System.String gsmNumber, System.String text, System.String messageType, System.String messageHeader, System.String messageStartDate, System.String messageExpireDate, System.Decimal messageId)
        {
            GsmNumber = gsmNumber;
            Text = text;
            MessageType = messageType;
            MessageHeader = messageHeader;
            MessageStartDate = messageStartDate;
            MessageExpireDate = messageExpireDate;
            MessageId = messageId;
        }
        public SmsMessage(System.String gsmNumber, System.String text, System.String messageType, System.String messageHeader, System.String messageStartDate, System.String messageExpireDate, System.String messageExclusionTimeStart, System.String messageExclusionTimeStop, System.Decimal messageId)
        {
            GsmNumber = gsmNumber;
            Text = text;
            MessageType = messageType;
            MessageHeader = messageHeader;
            MessageStartDate = messageStartDate;
            MessageExpireDate = messageExpireDate;
            MessageExclusionTimeStart = messageExclusionTimeStart;
            MessageExclusionTimeStop = messageExclusionTimeStop;
            MessageId = messageId;
        }

		[STAThread]
		protected static void  Main(System.String[] args)
		{
			
		}
	}
}