﻿/*
* Created on 15.May.2005
*/
using System;
using System.Text;
namespace xml.sender
{

    /// <author>  mustafa.bilge
    /// </author>
    /// <returns> Use when sending multi-sms i.e. send different message to different subscribers.
    /// </returns>
    public class SmsMultiSender : SmsBase
    {
        StringBuilder xmlToSend = new StringBuilder();
        public SmsMultiSender()
        {
            InitBlock();
        }
        private void InitBlock()
        {
            smsMessages = new System.Collections.ArrayList();
        }
        /// <returns> Returns the smsMessages.
        /// </returns>
        /// <param name="smsMessages">The smsMessages to set.
        /// </param>
        virtual public System.Collections.ArrayList SmsMessages
        {
            get
            {
                return smsMessages;
            }

            set
            {
                this.smsMessages = value;
            }

        }

        //UPGRADE_ISSUE: Class hierarchy differences between 'java.util.ArrayList' and 'System.Collections.ArrayList' may cause compilation errors. 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="jlca1186"'
        //UPGRADE_NOTE: The initialization of  'smsMessages' was moved to method 'InitBlock'. 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="jlca1005"'
        private System.Collections.ArrayList smsMessages;
        /* 
        * @see xml.sender.SmsBase#sendMessage()
        */
        public ResponseFromHost sendMessage(System.String xmlSentServlet)
        {
            return PostDataToHost(CreateXmlData(), xmlSentServlet);
        }
        public override ResponseFromHost sendMessage()
        {
            return PostDataToHost(CreateXmlData());
        }


        public ResponseFromHostV2 sendMessageV2(System.String xmlSentServlet)
        {
            return PostDataToHostV2(CreateXmlData(), xmlSentServlet);
        }

        public override ResponseFromHostV2 sendMessageV2()
        {
            isResponseMultiGroupId = true;
            return PostDataToHostV2(CreateXmlData());
        }

        public virtual void AddMessage(SmsMessage message)
        {
            //UPGRADE_TODO: The equivalent in .NET for method 'java.util.ArrayList.add' may return a different value. 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="jlca1043"'
            smsMessages.Add(message);
        }

        public virtual void AddMessage(System.String gsmNumber, System.String text)
        {
            SmsMessage smsMessage = new SmsMessage(gsmNumber, text);
            AddMessage(smsMessage);
        }

        public virtual void AddMessage(System.String gsmNumber, System.String text, System.String messageStartDate, System.String messageExpireDate)
        {
            SmsMessage smsMessage = new SmsMessage(gsmNumber, text, messageStartDate, messageExpireDate);
            AddMessage(smsMessage);
        }

        /*multi message_id*/
        public virtual void AddMessage(System.String gsmNumber, System.String text, Int64 messageId)
        {
            SmsMessage smsMessage = new SmsMessage(gsmNumber, text, messageId);
            AddMessage(smsMessage);
        }

        private string CreateXmlData()
        {
            xmlToSend.Remove(0, xmlToSend.Length);
            xmlToSend.Append("<?xml version=\"1.0\" encoding=\"utf-8\" ");
            xmlToSend.Append("?>");
            xmlToSend.Append("<message-context type=\"mmmgsd\" ");
            if (isResponseMultiGroupId)
            {
                xmlToSend.Append("version=\"2.0\" >");
            }
            else
            {
                xmlToSend.Append(">");
            }

            //xmlToSend.Append("<?xml version=\"1.0\" encoding=\"iso-8859-9\" ?>");
            //xmlToSend.Append("<message-context type=\"mmmgsd\">");
            xmlToSend.Append("<version>");
            xmlToSend.Append(Version);
            xmlToSend.Append("</version>");
            xmlToSend.Append("<exclusion-time-start>");
            xmlToSend.Append(ExclusionTimeStart);
            xmlToSend.Append("</exclusion-time-start>");
            xmlToSend.Append("<exclusion-time-stop>");
            xmlToSend.Append(ExclusionTimeStop);
            xmlToSend.Append("</exclusion-time-stop>");
            xmlToSend.Append("<username>");
            xmlToSend.Append(Username);
            xmlToSend.Append("</username>");
            xmlToSend.Append("<password>");
            xmlToSend.Append(Password);
            xmlToSend.Append("</password>");
            xmlToSend.Append("<email-report>");
            xmlToSend.Append(EmailReportAddress);
            xmlToSend.Append("</email-report>");
            xmlToSend.Append("<outbox-name>");
            xmlToSend.Append(OutboxName);
            xmlToSend.Append("</outbox-name>");
            xmlToSend.Append("<reference>");
            xmlToSend.Append(Reference);
            xmlToSend.Append("</reference>");
            xmlToSend.Append("<start-date>");
            xmlToSend.Append(StartDate);
            xmlToSend.Append("</start-date>");
            xmlToSend.Append("<expire-date>");
            xmlToSend.Append(ExpireDate);
            xmlToSend.Append("</expire-date>");

            

            xmlToSend.Append("<state>");
            if (0 < base.PackageState)
                xmlToSend.Append(base.PackageState);
            xmlToSend.Append("</state>");

            xmlToSend.Append("<total-count>");
            if (0 < base.TotalMessageCount)
                xmlToSend.Append(base.TotalMessageCount);
            xmlToSend.Append("</total-count>");

            xmlToSend.Append("<unit-count>");
            xmlToSend.Append(smsMessages.Count);
            xmlToSend.Append("</unit-count>");

            xmlToSend.Append("<trn-sqn>");
            if (0 < base.TrnSqn)
                xmlToSend.Append(base.TrnSqn);
            xmlToSend.Append("</trn-sqn>");

            xmlToSend.Append("<operation-process-id>");
            if (!string.IsNullOrEmpty(base.OperationProcessID))
                xmlToSend.Append(base.OperationProcessID);
            xmlToSend.Append("</operation-process-id>");

            xmlToSend.Append("<process-type>");
            if (!string.IsNullOrEmpty(base.ProcessType))
                xmlToSend.Append(base.ProcessType);
            xmlToSend.Append("</process-type>");

            xmlToSend.Append("<blacklist-filter>");
            xmlToSend.Append(base.IsBlacklistFilterActive ? 1 : 0);
            xmlToSend.Append("</blacklist-filter>");

            xmlToSend.Append("<optin-filter>");
            xmlToSend.Append(base.IsOptinFilterActive ? 1 : 0);
            xmlToSend.Append("</optin-filter>");

            xmlToSend.Append("<is-tckn>");
            xmlToSend.Append(base.IsTCKN ? 1 : 0);
            xmlToSend.Append("</is-tckn>");

            xmlToSend.Append("<is-vkn>");
            xmlToSend.Append(base.IsVKN ? 1 : 0);
            xmlToSend.Append("</is-vkn>");

            xmlToSend.Append("<channel>");
            xmlToSend.Append(base.Channel);
            xmlToSend.Append("</channel>");

            if (!string.IsNullOrEmpty(base.MultipleSend))
            {
                xmlToSend.Append("<multiple-send>");
                xmlToSend.Append(base.MultipleSend);
                xmlToSend.Append("</multiple-send>");
            }

            decimal generatedMessageId = -1;
            int c = 0;

            foreach (SmsMessage smsMessage in smsMessages)
            {
                if (generatedMessageId == -1)
                {
                    generatedMessageId = GetMessageId();
                }

                xmlToSend.Append("<message>");
                xmlToSend.Append("<gsmno>");
                xmlToSend.Append(smsMessage.GsmNumber);
                xmlToSend.Append("</gsmno>");
                xmlToSend.Append("<text>");
                xmlToSend.Append(smsMessage.Text);
                xmlToSend.Append("</text>");
                xmlToSend.Append("<message-id>");
                xmlToSend.Append(smsMessage.MessageId == -1 ? generatedMessageId + c : smsMessage.MessageId);//-1 ise unique üretilir
                xmlToSend.Append("</message-id>");
                if (!string.IsNullOrEmpty(smsMessage.MessageStartDate))
                {
                    xmlToSend.Append("<message-start-date>");
                    xmlToSend.Append(smsMessage.MessageStartDate);
                    xmlToSend.Append("</message-start-date>");
                    xmlToSend.Append("<message-expire-date>");
                    if (!string.IsNullOrEmpty(smsMessage.MessageExpireDate))
                        xmlToSend.Append(smsMessage.MessageExpireDate);
                    xmlToSend.Append("</message-expire-date>");
                }
                if (!string.IsNullOrEmpty(smsMessage.MessageExclusionTimeStart))
                {
                    xmlToSend.Append("<message-exclusion-time-start>");
                    xmlToSend.Append(smsMessage.MessageExclusionTimeStart);
                    xmlToSend.Append("</message-exclusion-time-start>");
                    xmlToSend.Append("<message-exclusion-time-stop>");
                    xmlToSend.Append(smsMessage.MessageExclusionTimeStop);
                    xmlToSend.Append("</message-exclusion-time-stop>");
                }

                xmlToSend.Append("</message>");

                c++;
            }

            xmlToSend.Append("</message-context>");

            return xmlToSend.ToString();
        }
    }
}