﻿using Newtonsoft.Json;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Configuration;
using System.Net;
using System.Text;

namespace xml.sender
{
    public class SmsReportV2
    {
        StringBuilder xmlToReport = new StringBuilder();

        virtual public System.String[] MessageIds
        {
            get
            {
                return messageId;
            }

            set
            {
                this.messageId = value;
            }

        }
        //UPGRADE_NOTE: Respective javadoc comments were merged.  It should be changed in order to comply with .NET documentation conventions.
        /// <returns> Returns the password.
        /// </returns>
        /// <param name="">password
        /// The password to set.
        /// </param>
        virtual public System.String Password
        {
            get
            {
                return password;
            }

            set
            {
                this.password = value;
            }

        }
        //UPGRADE_NOTE: Respective javadoc comments were merged.  It should be changed in order to comply with .NET documentation conventions.
        /// <returns> Returns the status.
        /// </returns>
        /// <param name="">status
        /// The status to set.
        /// </param>
        virtual public System.String Status
        {
            get
            {
                return status;
            }

            set
            {
                this.status = value;
            }

        }
        //UPGRADE_NOTE: Respective javadoc comments were merged.  It should be changed in order to comply with .NET documentation conventions.
        /// <returns> Returns the username.
        /// </returns>
        /// <param name="">username
        /// The username to set.
        /// </param>
        virtual public System.String Username
        {
            get
            {
                return username;
            }

            set
            {
                this.username = value;
            }

        }

        virtual public IWebProxy Proxy
        {
            set { _proxy = value; }
        }

        virtual public Int32 Timeout
        {
            get { return _timeout; }
            set { _timeout = value; }
        }

        private System.String username;
        private System.String password;
        private System.String[] messageId;
        private System.String status;

        private IWebProxy _proxy = null;
        private Int32 _timeout = 100;

        public SmsReportV2(System.String username, System.String password, System.String[] messageIds, System.String status)
        {
            Username = username;
            Password = password;
            MessageIds = messageIds;
            Status = status;
        }

        public SmsReportV2()
        {

        }

        private string CreateXmlData()
        {
            if (MessageIds == null || MessageIds.Length == 0)
            {
                throw new SmsCreationException("The MessageIds must be set.");
            }

            xmlToReport.Remove(0, xmlToReport.Length);

            xmlToReport.Append("<?xml version=\"1.0\" encoding=\"utf-8\" ");
            xmlToReport.Append("?>");
            xmlToReport.Append("<message-context >");
            xmlToReport.Append("<username>");
            xmlToReport.Append(Username);
            xmlToReport.Append("</username>");
            xmlToReport.Append("<password>");
            xmlToReport.Append(Password);
            xmlToReport.Append("</password>");

            xmlToReport.Append("<list>");
            foreach (string sm in MessageIds)
            {
                xmlToReport.Append("<message-id>");
                xmlToReport.Append(sm);
                xmlToReport.Append("</message-id>");
            }
            xmlToReport.Append("</list>");

            xmlToReport.Append("</message-context>");

            return xmlToReport.ToString();
        }

        //UPGRADE_ISSUE: The following fragment of code could not be parsed and was not converted. 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="jlca1156"'
        public MessageResponseV2 doReporting()
        {
            return doReporting(CreateXmlData(), ConfigurationSettings.AppSettings["XML_REPORT_SERVLET"]);
        }

        public MessageResponseV2 doReporting(string url)
        {
            return doReporting(CreateXmlData(), url);
        }

        //UPGRADE_ISSUE: The following fragment of code could not be parsed and was not converted. 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="jlca1156"'
        private MessageResponseV2 doReporting(string xmltoReport, string url)
        {
            ArrayList returnList = new ArrayList();

            HttpClient httpClient = new HttpClient(url, false);

            httpClient.connectAndPostData(xmltoReport, _proxy, (_timeout == 100 ? 0 : _timeout * 1000));
            string response = httpClient.ResponseAllString;

            //ResponseAll

            if (response == null)
            {
                throw new Exception("İletişim sorunu yaşandı. Lütfen daha sonra tekrar deneyiniz.");
            }

            MessageResponseV2 messageResponseArray = JsonConvert.DeserializeObject<MessageResponseV2>(response);

            return messageResponseArray;
        }
    }
}
