﻿/*
* Created on 15.May.2005
*/
using System;
using System.Text;
namespace xml.sender
{
	

	
	/// <author>  mustafa.bilge
	/// </author>
	/// <returns> Use when sending an sms to a subscriber.
	/// </returns>
	public class SmsToOne:SmsBase
	{
		public SmsToOne()
		{
			InitBlock();
		}
		private void  InitBlock()
		{
			message = new SmsMessage();
		}

		//UPGRADE_NOTE: The initialization of  'message' was moved to method 'InitBlock'. 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="jlca1005"'
		private SmsMessage message;  
		
		/* 
		* @see xml.sender.SmsBase#sendMessage()
		*/
		public override ResponseFromHost sendMessage()
		{
			SmsToMany smsToMany = new SmsToMany();
			System.String[] numbers = new System.String[]{message.GsmNumber};

            smsToMany.Version = this.Version;
            smsToMany.Username = this.Username;
            smsToMany.Password = this.Password;
            smsToMany.Originator = this.Originator;
            smsToMany.ExpireDate = this.ExpireDate;
            smsToMany.MessageHeader = this.MessageHeader; //messageHeader;
            smsToMany.MessageType = this.MessageType;// messageType;
            smsToMany.StartDate = this.StartDate;
			smsToMany.setGsmNumbers(numbers);
			smsToMany.Text =  message.Text; 
            smsToMany.ExclusionTimeStart = this.ExclusionTimeStart;
            smsToMany.ExclusionTimeStop = this.ExclusionTimeStop;

            /*multi message_id*/
            
			
			return smsToMany.sendMessage();
		}

        /*multi message_id*/
        public override ResponseFromHostV2 sendMessageV2()
        {
            SmsToMany smsToMany = new SmsToMany();

            SmsMessage[] smsMessages = new SmsMessage[1];
            smsMessages[0] = new SmsMessage();
            smsMessages[0].GsmNumber = message.GsmNumber;
            smsMessages[0].MessageId = message.MessageId;

            smsToMany.Version = this.Version;
            smsToMany.Username = this.Username;
            smsToMany.Password = this.Password;
            smsToMany.Originator = this.Originator;
            smsToMany.Channel = this.Channel;
            smsToMany.ExpireDate = this.ExpireDate;
            smsToMany.MessageHeader = this.MessageHeader; //messageHeader;
            smsToMany.MessageType = this.MessageType;// messageType;
            smsToMany.StartDate = this.StartDate;
            smsToMany.setGsmNumberAndMessageId(smsMessages);
            smsToMany.Text = message.Text;
            smsToMany.ExclusionTimeStart = this.ExclusionTimeStart;
            smsToMany.ExclusionTimeStop = this.ExclusionTimeStop;

            return smsToMany.sendMessageV2();
        }       
		
		/// <returns> Returns the message.
		/// </returns>
		public virtual SmsMessage getMessage()
		{
			return message;
		}
		/// <param name="message">The message to set.
		/// </param>
		public virtual void  setMessage(SmsMessage message)
		{
			this.message = message;
		}
		public virtual void  setMessage(System.String gsmNumber, System.String text)
		{
			SmsMessage smsMessage = new SmsMessage(gsmNumber, text);
			this.message = smsMessage;
		}
        public virtual void setMessage(System.String gsmNumber, System.String text, System.Decimal messageId)
        {
            SmsMessage smsMessage = new SmsMessage(gsmNumber, text, messageId);
            this.message = smsMessage;
        }
	}
}