﻿/*
* Created on 15.May.2005
*/
/// <author>  mustafa.bilge
/// </author>
/// <returns> This class is not accessible from outside.
/// </returns>
using System;
using System.Configuration;
using System.Net;
using System.Resources;
using System.Web;
using System.Collections;
using xml.sender;
using System.IO.Compression;
using System.IO;
using System.Text;

namespace xml.sender
{
	
	class HttpClient
	{
		virtual public System.String Response
		{
			get
			{
				System.String line = null;
				//System.IO.StreamReader reader = new System.IO.StreamReader(server.GetResponse().GetResponseStream());
				//UPGRADE_TODO: Expected value of parameters of constructor 'java.io.BufferedReader.BufferedReader' are different in the equivalent in .NET. 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="jlca1092"'
				//System.IO.StreamReader s = new System.IO.StreamReader(reader.BaseStream, System.Text.Encoding.UTF8);
                //System.IO.StreamReader s = new System.IO.StreamReader(server.GetResponse().GetResponseStream(), System.Text.Encoding.UTF8);

                Stream objStream = null;
				try
				{
                    objStream = server.GetResponse().GetResponseStream();


                    StreamReader objStreamReader = new StreamReader(objStream);
                    line = objStreamReader.ReadToEnd();
                    objStream.Close();

                    return line;
				}
				catch (System.Exception e)
				{
					throw new System.Exception("Unable to read input stream");
				}
				finally
				{
                    if (null != objStream)
                    {
                        objStream.Close();
                    }
				}
			}
			
		}
		virtual public ArrayList ResponseAll
		{
			get
			{
				String line;
				ArrayList lines = new ArrayList();
				System.IO.StreamReader reader = new System.IO.StreamReader(server.GetResponse().GetResponseStream());
				//UPGRADE_TODO: Expected value of parameters of constructor 'java.io.BufferedReader.BufferedReader' are different in the equivalent in .NET. 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="jlca1092"'
				System.IO.StreamReader s = new System.IO.StreamReader(reader.BaseStream, System.Text.Encoding.UTF8);
				try
				{
					while((line = s.ReadLine()) != null)
					{
						lines.Add(line);
					}
					return lines;
				}
				catch (System.Exception e)
				{
					throw new System.Exception("Unable to read input stream");
				}
				finally
				{
					s.Close();
				}
			}
			
		}
        virtual public string ResponseAllString
        {
            get
            {
                string line;
                StringBuilder lines = new StringBuilder();
                System.IO.StreamReader reader = new System.IO.StreamReader(server.GetResponse().GetResponseStream());
                //UPGRADE_TODO: Expected value of parameters of constructor 'java.io.BufferedReader.BufferedReader' are different in the equivalent in .NET. 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="jlca1092"'
                System.IO.StreamReader s = new System.IO.StreamReader(reader.BaseStream, System.Text.Encoding.UTF8);
                try
                {
                    while ((line = s.ReadLine()) != null)
                    {
                        lines.Append(line);
                    }

                    return lines.ToString();
                }
                catch (System.Exception e)
                {
                    throw new System.Exception("Unable to read input stream");
                }
                finally
                {
                    s.Close();
                }
            }

        }
		virtual public System.String ResponseAndDisconnect
		{
			get
			{
				System.String responseStr = Response;
				disconnect();
				return responseStr;
			}
			
		}

        virtual public ArrayList ResponseAllAndDisconnect
        {
            get
            {
                ArrayList responseStr = ResponseAll;
                disconnect();
                return responseStr;
            }

        }



		protected internal System.Uri url;
        protected internal System.Net.HttpWebRequest server;
        protected internal bool compressed;

        public HttpClient(System.String szUrl)
            : this(szUrl, false)
        {
        }

		/// <param name="szUrl:">String object for the URL
		/// </param>
		public HttpClient(System.String szUrl, bool compressed)
		{
			try
			{
				//UPGRADE_TODO: Class 'java.net.URL' was converted to a 'System.Uri' which does not throw an exception if a URL specifies an unknown protocol. 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="jlca1132"'
				url = new System.Uri(szUrl);
                this.compressed = compressed;
			}
			catch (System.Exception e)
			{
				throw new System.Exception("Invalid URL");
			}
		}
		
		public void connectAsGet() 
		{
			connect("GET");
		}
		public void connectAsPost()
		{
			connect("POST");
		}

		/// <param name="method:">String object for client method (POST, GET,...)
		/// </param>
        public virtual void connect(System.String method)
        {
            connect(method, null);
        }

        public virtual void connect(System.String method, IWebProxy proxy)
        {
            connect(method, proxy, 0);
        }

        public virtual void  connect(System.String method, IWebProxy proxy, int timeout_ms)
		{
			try
			{
				server = (System.Net.HttpWebRequest) System.Net.WebRequest.Create(url);

                if (0 < timeout_ms)
                {
                    server.Timeout = timeout_ms;
                }

				SettingReader sr = new SettingReader();

                try
                {
                    if (null != proxy)
                    {
                        server.Proxy = proxy;
                    }
                    else
                    {
                        string useProxy = sr.GetKeyValue("USE_PROXY");

                        if (null != useProxy)
                        {
                            // smsproxy.UseProxy;
                            // ConfigurationSettings.AppSettings["USE_PROXY"];
                            if (useProxy != "0")
                                SetProxy();
                            //UPGRADE_ISSUE: Method 'java.net.URLConnection.setDoInput' was not converted. 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="jlca1000_javanetURLConnectionsetDoInput_boolean"'
                        }
                    }
                }
                catch { }
				//server.setDoInput(true);
				//UPGRADE_ISSUE: Method 'java.net.URLConnection.setDoOutput' was not converted. 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="jlca1000_javanetURLConnectionsetDoOutput_boolean"'
				//server.setDoOutput(true);
				server.Method = method;
				//SupportClass.URLConnectionSupport.SetRequestProperty(server, "Content-type", "application/x-www-form-urlencoded");
                server.ContentType = "application/x-www-form-urlencoded";

                if (compressed)
                {
                    server.Headers.Add("Content-Encoding", "gzip");
                }

				//UPGRADE_ISSUE: Method 'java.net.URLConnection.connect' was not converted. 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="jlca1000_javanetURLConnectionconnect"'
				//server.connect();
			}
			catch (System.Exception e)
			{
				throw new System.Exception("Connection failed");
			}
		}

/*
		private void SetProxy()
		{
			string useProxy= ConfigurationSettings.AppSettings["USE_PROXY"];
			string proxyUrl = ConfigurationSettings.AppSettings["PROXY_ADRES"] + ":" +ConfigurationSettings.AppSettings["PROXY_PORT"];
			proxyUrl = "http://"+proxyUrl+"/";
			WebProxy proxy = new WebProxy(proxyUrl, false, null);
			string username = ConfigurationSettings.AppSettings["PROXY_USER_NAME"];
			string password = ConfigurationSettings.AppSettings["PROXY_PASSWORD"];
			if(username != "")
			{
				proxy.Credentials = new NetworkCredential(username, password, ConfigurationSettings.AppSettings["DOMAIN"]); 
			}

			if(useProxy == "1")
			{
				server.PreAuthenticate = true;
				server.Proxy = proxy;
			}
		}
*/
		private void SetProxy()
		{
			
			SettingReader sr = new SettingReader();
			string useProxy= sr.GetKeyValue("USE_PROXY");
				//smsproxy.UseProxy;
				// ConfigurationSettings.AppSettings["USE_PROXY"]
			string proxyUrl = sr.GetKeyValue("PROXY_ADRES")+":"+sr.GetKeyValue("PROXY_PORT");
				// smsproxy.ProxyAddress+":"+smsproxy.ProxyPort;
				//ConfigurationSettings.AppSettings["PROXY_ADRES"] + ":" +ConfigurationSettings.AppSettings["PROXY_PORT"];
			proxyUrl = "http://"+proxyUrl+"/";
			WebProxy proxy = new WebProxy(proxyUrl, false, null);
			string username = sr.GetKeyValue("PROXY_USER_NAME");
				//smsproxy.ProxyUsername;
				//ConfigurationSettings.AppSettings["PROXY_USER_NAME"];
			string password = sr.GetKeyValue("PROXY_PASSWORD");
				//smsproxy.ProxyPassword;
				//ConfigurationSettings.AppSettings["PROXY_PASSWORD"];
			if(username != "")
			{
				proxy.Credentials = new NetworkCredential(username, password,sr.GetKeyValue("DOMAIN")); 
				// ConfigurationSettings.AppSettings["DOMAIN"]
			}

			if(useProxy == "1")
			{
				server.PreAuthenticate = true;
				server.Proxy = proxy;
			}
		}

		public virtual void  disconnect()
		{
			server.GetResponse().Close();
		}
		
		public virtual void  displayResponse()
		{
			System.String line;
			System.IO.StreamReader reader = new System.IO.StreamReader(server.GetResponse().GetResponseStream());
			//UPGRADE_TODO: Expected value of parameters of constructor 'java.io.BufferedReader.BufferedReader' are different in the equivalent in .NET. 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="jlca1092"'
			System.IO.StreamReader s = new System.IO.StreamReader(reader.BaseStream, System.Text.Encoding.UTF8);
			try
			{
				line = s.ReadLine();
				while ((System.Object) line != null)
				{
					System.Console.Out.WriteLine(line);
					line = s.ReadLine();
				}
			}
			catch (System.Exception e)
			{
				throw new System.Exception("Unable to read input stream");
			}
			finally
			{
				s.Close();
			}
		}
		
            
		public virtual void  connectAndPostData(System.String s)
        {
            connectAndPostData(s, null);
        }

        public virtual void connectAndPostData(System.String s, int timeout_ms)
        {
            connectAndPostData(s, null, timeout_ms);
        }

        public virtual void connectAndPostData(System.String s, IWebProxy proxy)
		{
            connect("POST", proxy);
			post(s);
		} 

        public virtual void connectAndPostData(System.String s, IWebProxy proxy, int timeout_ms)
        {
            connect("POST", proxy, timeout_ms);
            post(s);
        }

		public virtual void  post(System.String s)
		{
            try
			{
                if (compressed)
                {
                    postZipped(s);
                }
                else
                {
                    postUnzipped(s);
                }
            }
			catch (System.Exception e)
			{
				throw new System.Exception("Unable to write to output stream");
			}

		}

        private void postUnzipped(System.String s)
        {
            //System.IO.StreamWriter writer = new System.IO.StreamWriter(server.GetRequestStream());
            Stream writer = server.GetRequestStream();
            try
            {
                byte[] buffer = Encoding.UTF8.GetBytes(s);
                //UPGRADE_NOTE: Exceptions thrown by the equivalent in .NET of method 'java.io.BufferedWriter.write' may be different. 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="jlca1099"'
                writer.Write(buffer, 0, buffer.Length);
            }
            catch (System.Exception e)
            {
                throw e;
            }
            finally
            {
                writer.Flush();
                writer.Close();
            }
        } 

        private void postZipped(System.String s)
        {  
            GZipStream zip = new GZipStream(server.GetRequestStream(), CompressionMode.Compress); 

            try
            {
                byte[] buffer = Encoding.UTF8.GetBytes(s);

                zip.Write(buffer, 0, buffer.Length); 
            }
            catch (System.Exception e)
            {
                throw e;
            }
            finally
            { 
                zip.Close();
            }
        }
		
		[STAThread]
		protected static void  Main(System.String[] argv)
		{
			if (argv.Length == 0)
			{
				System.Console.Out.WriteLine("Usage: java HttpClient url\r\n");
				System.Environment.Exit(0);
			}
			
			try
			{
				HttpClient c = new HttpClient(argv[0]);
				c.connect("GET");
				c.displayResponse();
				c.disconnect();
				
				c.connect("POST");
				c.post("data=Posted request");
				c.displayResponse();
				c.disconnect();
				
				c.connect("POST");
				c.post("data=2nd request");
				c.displayResponse();
				c.disconnect();
			}
			catch (System.Exception e)
			{
				SupportClass.WriteStackTrace(e, Console.Error);
			}
		}
	}
}